<?php
namespace EMS\PortalFuncionario\Geral\Controllers;

use Zeedhi\Framework\Controller\Crud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;
use Doctrine\ORM\EntityManager;

use EMS\PortalFuncionario\Geral\Services\SolicitacaoService;

class SolicitacaoController {

    public function __construct(EntityManager $entityManager, SolicitacaoService $solicitacao) {
        $this->entityManager        = $entityManager;
        $this->solicitacao     = $solicitacao;
    }

    public function getSolicitacao(DTO\Request\Filter $request, DTO\Response $response) {
        try {
            $params = $request->getParameters();
            $comunicados = $this->solicitacao->getSolicitacao(
                $params['NRVINCULOM'],
                $params['NRORG'],
                $params['CDOPERADOR']
            );
            $response->addDataSet(new DataSet('data', $comunicados));
        } catch (\Exception $e) {
            $response->addMessage(new DTO\Response\Message($e->getMessage(), DTO\Response\Message::TYPE_ERROR));
        }
    }

    public function getSolicitacao_quantidade(DTO\Request\Filter $request, DTO\Response $response) {
        try {
            $params = $request->getParameters();
            $comunicados = $this->solicitacao->getSolicitacao_quantidade(
                $params['NRVINCULOM'],
                $params['NRORG'],
                $params['CDOPERADOR']
            );
            $response->addDataSet(new DataSet('data', $comunicados));
        } catch (\Exception $e) {
            $response->addMessage(new DTO\Response\Message($e->getMessage(), DTO\Response\Message::TYPE_ERROR));
        }
    }
}
